﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=BLEExample.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private btnReadData As B4XView
	Private btnDisconnect As B4XView
	Private btnScan As B4XView
	Private lblDeviceStatus As B4XView
	Private lblState As B4XView
	Private pbReadData As B4XLoadingIndicator
	Private clv As CustomListView
	#if B4A
	Private manager As BleManager2
	Private rp As RuntimePermissions
	#else if B4i
	Private manager As BleManager
	#end if
	Private currentStateText As String = "UNKNOWN"
	Private currentState As Int
	Private connected As Boolean = False
	Private ConnectedName As String
	Private ConnectedID As String
	Private ConnectedServices As List
	Private pbScan As B4XLoadingIndicator
	
	'///////////////////////////
	
	Type NameAndMac (Name As String, Mac As String)
	
	
	'=========================================================================================
	' Your Services and their Characteristics
	
	Public SERVICE_A As String = 			"487fd381-0000-3c38-73e3-b5e3c22a3134"	' UUID of a Service of yours
	' and its characteristics
	Public SERVICE_A_CHAR_1 As String = 	"487fd381-00a1-3c38-73e3-b5e3c22a3134"
	Public SERVICE_A_CHAR_2 As String = 	"487fd381-00b2-3c38-73e3-b5e3c22a3134"
	Public SERVICE_A_CHAR_3 As String = 	"487fd381-00c3-3c38-73e3-b5e3c22a3134"
	' . . .  etc
	'*******************************************************************************************


	'=========================================================================================
	' Example of a general GATT Service and its Characteristics
	' note:   Peripheral device should have it implemented to be able to get any data in this example
	' DEVICE INFORMATION SERVICE
	Public INFO_SERVICE_UUID As String =     "0000180a-0000-1000-8000-00805f9b34fb"
	'         INFORMATION SERVICE characteristics
	Public MODEL_NUMBER As String =          "00002a24-0000-1000-8000-00805f9b34fb"         ' 	Model Number String
	Public SERIAL_NUMBER As String =         "00002a25-0000-1000-8000-00805f9b34fb"         '   Serial Number String
	Public FIRMWARE_REVISION As String =     "00002a26-0000-1000-8000-00805f9b34fb"         '   Firmware Revision String
	Public HARDWARE_REVISION As String =     "00002a27-0000-1000-8000-00805f9b34fb"         '   Software Revision String
	Public SOFTWARE_REVISION As String =     "00002a28-0000-1000-8000-00805f9b34fb"         '   Software Revision String
	Public MANUFACTURER As String =          "00002a29-0000-1000-8000-00805f9b34fb"
	'=========================================================================================
	
	
	' declare a timer
	Dim scanTimeout As Timer
	
	Public conModelNumber As String = ""
	Public conSerialNumber As String = ""
	Public conFirmwareRevision As String = ""
	Public conHardwareRevision As String = ""
	Public conSoftwareRevision As String = ""
	Public conManufacturerName As String = ""
	
	Private heardDeviceList As List
	Private combineHeardDeviceList As List
	
	
	
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True

	scanTimeout.Initialize("scanTimeout", 3000)    ' arbitrary 3 seconds period
	
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	
	Root = Root1
	Root.LoadLayout("1")
	B4XPages.SetTitle(Me, "BLE Example 1")
	
	'
	heardDeviceList.Initialize
	combineHeardDeviceList.Initialize
	
	'
	manager.Initialize("manager")
	StateChanged
End Sub

Public Sub StateChanged
	lblState.Text = currentStateText
	If connected Then
		lblDeviceStatus.Text = "Connected: " & ConnectedName
	Else
		lblDeviceStatus.Text = "Not connected"
	End If
	btnDisconnect.Enabled = connected
	btnScan.Enabled = Not(connected)
	pbReadData.Hide
	pbScan.Hide
	btnReadData.Enabled = connected
	btnScan.Enabled = (currentState = manager.STATE_POWERED_ON) And connected = False
End Sub

Sub btnScan_Click
	#if B4A
	'Don't forget to add permission to manifest
	Dim Permissions As List
	Dim phone As Phone
	If phone.SdkVersion >= 31 Then
		Permissions = Array("android.permission.BLUETOOTH_SCAN", "android.permission.BLUETOOTH_CONNECT", rp.PERMISSION_ACCESS_FINE_LOCATION)
	Else
		Permissions = Array(rp.PERMISSION_ACCESS_FINE_LOCATION)
	End If
	For Each per As String In Permissions
		rp.CheckAndRequest(per)
		Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
		If Result = False Then
			ToastMessageShow("No permission: " & Permission, True)
			Return
		End If
	Next
	#end if
	pbScan.Show
	StartScan
End Sub

Sub btnDisconnect_Click
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub btnReadData_Click
	pbReadData.Show
	clv.Clear
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub


Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	StateChanged
End Sub


Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore

	Dim nm As NameAndMac
	nm.Initialize
	nm.Name = Name
	nm.Mac = Id
		
	'If nm.Name = "yourBLEdevName" Then			' you could filter heard devices by their BLE "Name"
		heardDeviceList.Add(nm)
		combineHeardDeviceList.Add(nm.Name & " - "&nm.Mac)
	'End If
	
End Sub


Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else
		Log("Start Scanning")
		scanTimeout.Enabled = True    ' start this timer
		manager.Scan2( Null, False)    ' don't allow duplicates
	End If
End Sub


'=======================================================================
' Receiving GATT Data
'=======================================================================
Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
	pbReadData.Hide
	
	Log("++++++++++++++++++++++++++++++++++++++++++++++")
	LogColor("Service UID = "&ServiceId, Colors.Cyan)
	LogColor("Characteristic size = "&Characteristics.Size, Colors.yellow)
	
	'=========================================================================================
	' Here you can check if the Service(s) you are interested in have data available and process it
	
	
	' check if it is a general InfoService UUID
    If ServiceId = INFO_SERVICE_UUID Then                
        For Each id As String In Characteristics.Keys
            Dim dataContent() As Byte = Characteristics.Get(id)
            Select id
                Case MODEL_NUMBER
                    conModelNumber = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("Model: " & conModelNumber)
                Case SERIAL_NUMBER
                    conSerialNumber = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("Serial no.: " & conSerialNumber)
                Case FIRMWARE_REVISION
                    conFirmwareRevision = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("FW rev: " & conFirmwareRevision)
                Case HARDWARE_REVISION
                    conHardwareRevision = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("HW rev: " & conHardwareRevision)
                Case SOFTWARE_REVISION
                    conSoftwareRevision = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("SW rev: " & conSoftwareRevision)
                Case MANUFACTURER
                    conManufacturerName = BytesToString(dataContent, 0, dataContent.Length, "UTF8")
                    Log("Manufacturer: " & conManufacturerName)
            End Select
        Next
    End If
	
 
   
	' look for your Service(s)
	If ServiceId = SERVICE_A Then                                   ' check if it your Service UUID
		
		' some Debug to Log Characteristics properties
		For Each c As String In Characteristics.Keys
			PrintCharProperties(c, manager.GetCharacteristicProperties(ServiceId, c))
		Next
		
		
		' and go through your service characteristics UUID
		
		If Characteristics.ContainsKey(SERVICE_A_CHAR_1) Then    ' and if Characteristic is the one you're after
            If Characteristics.Getvalueat(0)<>Null Then
                LogColor("Got my Service-Characteristic : Srv(A)-Char(1)", Colors.blue)
                Dim b() As Byte = Characteristics.Getvalueat(0)     ' <<<< here you can get the Characteristic data and an array
                                                                    ' for further processing ...
				LogColor("Char-1 data(0) = "& b(0) , Colors.Cyan) ' just an example ....													
                '...
            End If
		End If
		
		If Characteristics.ContainsKey(SERVICE_A_CHAR_2) Then    ' and if Characteristic is the one you're after
			If Characteristics.Getvalueat(0)<>Null Then
				LogColor("Got my Service-Characteristic : Srv(A)-Char(2)", Colors.blue)
				Dim b() As Byte = Characteristics.Getvalueat(0)     ' <<<< here you can get the Characteristic data and an array
				' for further processing ...
				LogColor("Char-2 data(0) = "& b(0) , Colors.Cyan) ' just an example ....
				'...
			End If
		End If
		
		If Characteristics.ContainsKey(SERVICE_A_CHAR_3) Then    ' and if Characteristic is the one you're after
			If Characteristics.Getvalueat(0)<>Null Then
				LogColor("Got my Service-Characteristic : Srv(A)-Char(3)", Colors.blue)
				Dim b() As Byte = Characteristics.Getvalueat(0)     ' <<<< here you can get the Characteristic data and an array
				' for further processing ...
				LogColor("Char-3 data(0) = "& b(0) , Colors.Cyan) ' just an example ....
				'...
			End If
		End If	
		
	End If
	

End Sub


'==============================================================================
' Sending GATT Data to a Characteristic
'
' * Note: add your own Button or whatever method to call this sub for test
'============================================================================== 
public Sub write_CHAR_1
	' example of an array to be send
	Dim myCharArray(150) As Byte
	myCharArray(0) = 5	'
	' ...
	manager.WriteData(SERVICE_A, SERVICE_A_CHAR_1, myCharArray)
	wait for Manager_WriteComplete(Characteristic As String, Status As Int)
	' ...
End Sub
'==============================================================================


Sub Manager_WriteComplete (Characteristic As String, Status As Int)
	If connected = False Then Return
'	Log("Writecomplete: " & Characteristic)
'	Log("Status=" & Status)
End Sub





Sub Manager_Disconnected
	LogColor("Disconnected", Colors.red)
	connected = False
	StateChanged
End Sub

Sub Manager_Connected (services As List)
	
	
	' Here the Service Characteristics that need Notify should be Enabled (with some delay in between calls),
	' using CallSubPlus for example ...
	
	
	Try
		' the call to Enable Notify for a Characteristic looks like:
		manager.SetNotify(SERVICE_A,SERVICE_A_CHAR_1,True) ' <<< will CRASH if the Service/Char is not implemented both sides (central & peripheral)
		'
		' manager.SetNotify(SERVICE_A,SERVICE_A_CHAR_2,True)
		' manager.SetNotify(SERVICE_A,SERVICE_A_CHAR_3,True)
	
		connected = True
		ConnectedServices = services
		StateChanged
	
		LogColor("Connected", Colors.Green)
	Catch
		Log(LastException)	' CRASH with: "Service not found"  error 
	End Try
	
	
	
	
	
End Sub



private Sub scanTimeout_Tick
	manager.StopScan                        ' say we heard'em all, can stop scanning for now
	StateChanged
	scanTimeout.Enabled = False             ' and stop this timer
    
	If connected = False Then
		InputListAsync(combineHeardDeviceList, "Choose device to connect", -1, True)    ' show list and choose device
		Wait For InputList_Result (Index As Int)
		If Index <> DialogResponse.CANCEL Then
			
			Dim device As NameAndMac
			device.Initialize
			device = heardDeviceList.Get(Index)
			ConnectedName = device.Name             ' connected BLE device Name
			ConnectedID = device.Mac                ' connected BLE MAC address
			LogColor("connecting to: "&ConnectedName&" | MAC adrs = "&ConnectedID, Colors.Green)
			manager.Connect2(device.Mac, False)     ' here you start connecting to chosen device
			
			' disabling auto connect can make the connection quicker
			ProgressDialogShow2($"Trying to connect to: ${device.Name} (${device.Mac})"$, False)    ' user UI related
			Sleep(3000)            ' some drama
			ProgressDialogHide
		End If
		'
		heardDeviceList.clear
		combineHeardDeviceList.Clear
		'
	End If
End Sub







'
Sub PrintCharProperties(Characteristic As String, Properties As Int)
	Log($"${Characteristic} Properties:"$)

	Dim props As Map = CreateMap(1: "Broadcast", 2: "Read", 4: "WriteWithoutResponse", 8: "Write", 0x10: "Notify")
	For Each key As Int In props.Keys
		If Bit.And(Properties, key) <> 0 Then Log(props.Get(key))
	Next
End Sub
